diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index cc6be16..586ae91 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -25,6 +25,7 @@
 
 #include "access/clog.h"
 #include "access/multixact.h"
+#include "access/nbtree.h"
 #include "access/subtrans.h"
 #include "access/transam.h"
 #include "access/tuptoaster.h"
@@ -45,6 +46,7 @@
 #include "storage/ipc.h"
 #include "storage/pmsignal.h"
 #include "storage/procarray.h"
+#include "storage/sinval.h"
 #include "storage/smgr.h"
 #include "storage/spin.h"
 #include "utils/builtins.h"
@@ -53,13 +55,14 @@
 #include "utils/ps_status.h"
 #include "pg_trace.h"
 
-
 /* File path names (all relative to $PGDATA) */
 #define BACKUP_LABEL_FILE		"backup_label"
 #define BACKUP_LABEL_OLD		"backup_label.old"
 #define RECOVERY_COMMAND_FILE	"recovery.conf"
 #define RECOVERY_COMMAND_DONE	"recovery.done"
 
+/* copied from tcopprot.h rather than include whole file */
+extern	int	PostAuthDelay;
 
 /* User-settable parameters */
 int			CheckPointSegments = 3;
@@ -133,6 +136,8 @@ TimeLineID	ThisTimeLineID = 0;
  */
 bool		InRecovery = false;
 
+static 	XLogRecPtr	LastRec;
+
 /*
  * Local copy of SharedRecoveryInProgress variable. True actually means "not
  * known, need to check the shared state".
@@ -152,7 +157,7 @@ static bool LocalRecoveryInProgress = true;
 static int	LocalXLogInsertAllowed = -1;
 
 /* Are we recovering using offline XLOG archives? */
-static bool InArchiveRecovery = false;
+bool InArchiveRecovery = false;
 
 /* Was the last xlog file restored from archive, or local? */
 static bool restoredFromArchive = false;
@@ -160,12 +165,32 @@ static bool restoredFromArchive = false;
 /* options taken from recovery.conf */
 static char *recoveryRestoreCommand = NULL;
 static char *recoveryEndCommand = NULL;
-static bool recoveryTarget = false;
 static bool recoveryTargetExact = false;
 static bool recoveryTargetInclusive = true;
 static TransactionId recoveryTargetXid;
 static TimestampTz recoveryTargetTime;
+static XLogRecPtr recoveryTargetLSN;
+static int recoveryTargetAdvance = 0;
+bool InHotStandby = true;
+
+/* recovery target modes */
+#define	RECOVERY_TARGET_NONE				0
+#define RECOVERY_TARGET_PAUSE_ALL			1
+#define RECOVERY_TARGET_PAUSE_XID			2
+#define RECOVERY_TARGET_PAUSE_TIME			3
+#define RECOVERY_TARGET_PAUSE_LSN			4
+#define RECOVERY_TARGET_ADVANCE				5
+#define RECOVERY_TARGET_STOP_IMMEDIATE		6
+#define RECOVERY_TARGET_STOP_XID			7
+#define RECOVERY_TARGET_STOP_TIME			8
+static int recoveryTargetMode = RECOVERY_TARGET_NONE;
+static bool recoveryStartsPaused = false;
+
+#define DEFAULT_MAX_STANDBY_DELAY 	30
+int maxStandbyDelay = DEFAULT_MAX_STANDBY_DELAY;
+
 static TimestampTz recoveryLastXTime = 0;
+static TransactionId recoveryLastXid = InvalidTransactionId;
 
 /* if recoveryStopsHere returns true, it saves actual stop xid/time here */
 static TransactionId recoveryStopXid;
@@ -360,6 +385,16 @@ typedef struct XLogCtlData
 	/* end+1 of the last record replayed (or being replayed) */
 	XLogRecPtr	replayEndRecPtr;
 
+	int				recoveryTargetMode;
+	TransactionId	recoveryTargetXid;
+	TimestampTz		recoveryTargetTime;
+	int				recoveryTargetAdvance;
+	XLogRecPtr		recoveryTargetLSN;
+
+	TimestampTz 	recoveryLastXTime;
+	TransactionId 	recoveryLastXid;
+	XLogRecPtr		recoveryLastRecPtr;
+
 	slock_t		info_lck;		/* locks shared variables shown above */
 } XLogCtlData;
 
@@ -899,25 +934,6 @@ begin:;
 	FIN_CRC32(rdata_crc);
 	record->xl_crc = rdata_crc;
 
-#ifdef WAL_DEBUG
-	if (XLOG_DEBUG)
-	{
-		StringInfoData buf;
-
-		initStringInfo(&buf);
-		appendStringInfo(&buf, "INSERT @ %X/%X: ",
-						 RecPtr.xlogid, RecPtr.xrecoff);
-		xlog_outrec(&buf, record);
-		if (rdata->data != NULL)
-		{
-			appendStringInfo(&buf, " - ");
-			RmgrTable[record->xl_rmid].rm_desc(&buf, record->xl_info, rdata->data);
-		}
-		elog(LOG, "%s", buf.data);
-		pfree(buf.data);
-	}
-#endif
-
 	/* Record begin of record in appropriate places */
 	ProcLastRecPtr = RecPtr;
 	Insert->PrevRecord = RecPtr;
@@ -4851,7 +4867,7 @@ readRecoveryCommandFile(void)
 			ereport(LOG,
 					(errmsg("recovery_target_xid = %u",
 							recoveryTargetXid)));
-			recoveryTarget = true;
+			recoveryTargetMode = RECOVERY_TARGET_STOP_XID;
 			recoveryTargetExact = true;
 		}
 		else if (strcmp(tok1, "recovery_target_time") == 0)
@@ -4862,7 +4878,7 @@ readRecoveryCommandFile(void)
 			 */
 			if (recoveryTargetExact)
 				continue;
-			recoveryTarget = true;
+			recoveryTargetMode = RECOVERY_TARGET_STOP_TIME;
 			recoveryTargetExact = false;
 
 			/*
@@ -4889,6 +4905,51 @@ readRecoveryCommandFile(void)
 			ereport(LOG,
 					(errmsg("recovery_target_inclusive = %s", tok2)));
 		}
+		else if (strcmp(tok1, "recovery_connections") == 0)
+		{
+			/*
+			 * enables/disables snapshot processing and user connections
+			 */
+			if (!parse_bool(tok2, &InHotStandby))
+				  ereport(ERROR,
+							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					  errmsg("parameter \"recovery_connections\" requires a Boolean value")));
+			ereport(LOG,
+					(errmsg("recovery_connections = %s", tok2)));
+		}
+		else if (strcmp(tok1, "recovery_starts_paused") == 0)
+		{
+			/*
+			 * enables/disables snapshot processing and user connections
+			 */
+			if (!parse_bool(tok2, &recoveryStartsPaused))
+				  ereport(ERROR,
+							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					  errmsg("parameter \"recovery_starts_paused\" requires a Boolean value")));
+
+			ereport(LOG,
+					(errmsg("recovery_starts_paused = %s", tok2)));
+		}
+		else if (strcmp(tok1, "max_standby_delay") == 0)
+		{
+			errno = 0;
+			maxStandbyDelay = (TransactionId) strtoul(tok2, NULL, 0);
+			if (errno == EINVAL || errno == ERANGE)
+				ereport(FATAL,
+				 (errmsg("max_standby_delay is not a valid number: \"%s\"",
+						 tok2)));
+			/*
+			 * 2E6 seconds is about 23 days. Allows us to measure delay in
+			 * milliseconds.
+			 */
+			if (maxStandbyDelay > INT_MAX || maxStandbyDelay < -1)
+				ereport(FATAL,
+				 (errmsg("max_standby_delay must be between -1 (wait forever) and 2 000 000 secs")));
+
+			ereport(LOG,
+					(errmsg("max_standby_delay = %u",
+							maxStandbyDelay)));
+		}
 		else
 			ereport(FATAL,
 					(errmsg("unrecognized recovery parameter \"%s\"",
@@ -5056,8 +5117,8 @@ exitArchiveRecovery(TimeLineID endTLI, uint32 endLogId, uint32 endLogSeg)
 }
 
 /*
- * For point-in-time recovery, this function decides whether we want to
- * stop applying the XLOG at or after the current record.
+ * For archive recovery, this function decides whether we want to
+ * pause or stop applying the XLOG at or after the current record.
  *
  * Returns TRUE if we are stopping, FALSE otherwise.  On TRUE return,
  * *includeThis is set TRUE if we should apply this record before stopping.
@@ -5070,72 +5131,285 @@ exitArchiveRecovery(TimeLineID endTLI, uint32 endLogId, uint32 endLogSeg)
 static bool
 recoveryStopsHere(XLogRecord *record, bool *includeThis)
 {
-	bool		stopsHere;
-	uint8		record_info;
-	TimestampTz recordXtime;
+	bool		stopsHere = false;
+	bool		pauseHere = false;
+	static bool    	paused = false;
+	uint8		record_info = 0;        /* valid iff (is_xact_completion_record) */
+	TimestampTz recordXtime = 0;
+	bool        is_xact_completion_record = false;
 
 	/* We only consider stopping at COMMIT or ABORT records */
-	if (record->xl_rmid != RM_XACT_ID)
-		return false;
-	record_info = record->xl_info & ~XLR_INFO_MASK;
-	if (record_info == XLOG_XACT_COMMIT)
+	if (record->xl_rmid == RM_XACT_ID)
 	{
-		xl_xact_commit *recordXactCommitData;
+		record_info = record->xl_info & ~XLR_INFO_MASK;
+		if (record_info == XLOG_XACT_COMMIT)
+		{
+			xl_xact_commit *recordXactCommitData;
 
-		recordXactCommitData = (xl_xact_commit *) XLogRecGetData(record);
-		recordXtime = recordXactCommitData->xact_time;
-	}
-	else if (record_info == XLOG_XACT_ABORT)
-	{
-		xl_xact_abort *recordXactAbortData;
+			recordXactCommitData = (xl_xact_commit *) XLogRecGetData(record);
+			recordXtime = recordXactCommitData->xact_time;
+			is_xact_completion_record = true;
+		}
+		else if (record_info == XLOG_XACT_ABORT)
+		{
+			xl_xact_abort *recordXactAbortData;
 
-		recordXactAbortData = (xl_xact_abort *) XLogRecGetData(record);
-		recordXtime = recordXactAbortData->xact_time;
-	}
-	else
-		return false;
+			recordXactAbortData = (xl_xact_abort *) XLogRecGetData(record);
+			recordXtime = recordXactAbortData->xact_time;
+			is_xact_completion_record = true;
+		}
 
-	/* Do we have a PITR target at all? */
-	if (!recoveryTarget)
-	{
-		recoveryLastXTime = recordXtime;
-		return false;
+		/* Remember the most recent COMMIT/ABORT time for logging purposes */
+		if (is_xact_completion_record)
+		{
+			recoveryLastXTime = recordXtime;
+			recoveryLastXid = record->xl_xid;
+		}
 	}
 
-	if (recoveryTargetExact)
+	do
 	{
+		int	prevRecoveryTargetMode = recoveryTargetMode;
+
+		CHECK_FOR_INTERRUPTS();
+
 		/*
-		 * there can be only one transaction end record with this exact
-		 * transactionid
-		 *
-		 * when testing for an xid, we MUST test for equality only, since
-		 * transactions are numbered in the order they start, not the order
-		 * they complete. A higher numbered xid will complete before you about
-		 * 50% of the time...
+		 * Check if we were requested to exit without finishing
+		 * recovery.
 		 */
-		stopsHere = (record->xl_xid == recoveryTargetXid);
-		if (stopsHere)
-			*includeThis = recoveryTargetInclusive;
-	}
-	else
-	{
+		if (shutdown_requested)
+			proc_exit(1);
+
 		/*
-		 * there can be many transactions that share the same commit time, so
-		 * we stop after the last one, if we are inclusive, or stop at the
-		 * first one if we are exclusive
+		 * Let's see if user has updated our recoveryTargetMode.
 		 */
-		if (recoveryTargetInclusive)
-			stopsHere = (recordXtime > recoveryTargetTime);
-		else
-			stopsHere = (recordXtime >= recoveryTargetTime);
-		if (stopsHere)
-			*includeThis = false;
+		{
+			/* use volatile pointer to prevent code rearrangement */
+			volatile XLogCtlData *xlogctl = XLogCtl;
+
+			SpinLockAcquire(&xlogctl->info_lck);
+			recoveryTargetMode = xlogctl->recoveryTargetMode;
+			if (recoveryTargetMode != RECOVERY_TARGET_NONE)
+			{
+				recoveryTargetXid = xlogctl->recoveryTargetXid;
+				recoveryTargetTime = xlogctl->recoveryTargetTime;
+
+				/* Don't reset counter while we're advancing */
+				if (recoveryTargetAdvance <= 0)
+				{
+					recoveryTargetAdvance = xlogctl->recoveryTargetAdvance;
+					xlogctl->recoveryTargetAdvance = 0;
+				}
+			}
+			if (is_xact_completion_record)
+			{
+				xlogctl->recoveryLastXTime = recordXtime;
+				xlogctl->recoveryLastXid = record->xl_xid;
+			}
+			xlogctl->recoveryLastRecPtr = LastRec;
+			SpinLockRelease(&xlogctl->info_lck);
+		}
+
+		/* Decide how to act on any pause target */
+		switch (recoveryTargetMode)
+		{
+			case RECOVERY_TARGET_PAUSE_LSN:
+					return false;
+
+			case RECOVERY_TARGET_NONE:
+					/*
+					 * If we aren't paused and we're not looking to stop,
+					 * just exit out quickly and get on with recovery.
+					 */
+					if (paused)
+					{
+						ereport(LOG,
+								(errmsg("recovery restarting after pause")));
+						set_ps_display("recovery continues", false);
+						paused = false;
+					}
+					return false;
+
+			case RECOVERY_TARGET_PAUSE_ALL:
+					pauseHere = true;
+					break;
+
+			case RECOVERY_TARGET_ADVANCE:
+					if (paused)
+					{
+						if (recoveryTargetAdvance-- > 0)
+						{
+							elog(LOG, "recovery advancing 1 record");
+							return false;
+						}
+						else
+							break;
+					}
+
+					if (recoveryTargetAdvance-- <= 0)
+						pauseHere = true;
+					break;
+
+			case RECOVERY_TARGET_STOP_IMMEDIATE:
+			case RECOVERY_TARGET_STOP_XID:
+			case RECOVERY_TARGET_STOP_TIME:
+					paused = false;
+					break;
+
+			/*
+			 * If we're paused, and mode has changed reset to allow new settings
+			 * to apply and maybe allow us to continue.
+			 */
+			if (paused && prevRecoveryTargetMode != recoveryTargetMode)
+				paused = false;
+
+			case RECOVERY_TARGET_PAUSE_XID:
+					/*
+					 * there can be only one transaction end record with this exact
+					 * transactionid
+					 *
+					 * when testing for an xid, we MUST test for equality only, since
+					 * transactions are numbered in the order they start, not the order
+					 * they complete. A higher numbered xid will complete before you about
+					 * 50% of the time...
+					 */
+					if (is_xact_completion_record)
+						pauseHere = (record->xl_xid == recoveryTargetXid);
+					break;
+
+			case RECOVERY_TARGET_PAUSE_TIME:
+					/*
+					 * there can be many transactions that share the same commit time, so
+					 * we pause after the last one, if we are inclusive, or pause at the
+					 * first one if we are exclusive
+					 */
+					if (is_xact_completion_record)
+					{
+						if (recoveryTargetInclusive)
+							pauseHere = (recoveryLastXTime > recoveryTargetTime);
+						else
+							pauseHere = (recoveryLastXTime >= recoveryTargetTime);
+					}
+					break;
+
+			default:
+					ereport(WARNING,
+							(errmsg("unknown recovery mode %d, continuing recovery",
+											recoveryTargetMode)));
+					return false;
+		}
+
+		/*
+		 * If we just entered pause, issue log messages
+		 */
+		if (pauseHere && !paused)
+		{
+			if (is_xact_completion_record)
+			{
+				if (record_info == XLOG_XACT_COMMIT)
+					ereport(LOG,
+						(errmsg("recovery pausing before commit of transaction %u, log time %s",
+									record->xl_xid,
+									timestamptz_to_str(recoveryLastXTime))));
+				else
+					ereport(LOG,
+						(errmsg("recovery pausing before abort of transaction %u, log time %s",
+									record->xl_xid,
+									timestamptz_to_str(recoveryLastXTime))));
+			}
+			else
+				ereport(LOG,
+						(errmsg("recovery pausing; last recovered transaction %u, "
+								"last recovered xact timestamp %s",
+									recoveryLastXid,
+									timestamptz_to_str(recoveryLastXTime))));
+
+			set_ps_display("recovery paused", false);
+
+			paused = true;
+		}
+
+		/*
+		 * Pause for a while before rechecking mode at top of loop.
+		 */
+		if (paused)
+		{
+			recoveryTargetAdvance = 0;
+
+			/*
+			 * Update the recoveryTargetMode
+			 */
+			{
+				/* use volatile pointer to prevent code rearrangement */
+				volatile XLogCtlData *xlogctl = XLogCtl;
+
+				SpinLockAcquire(&xlogctl->info_lck);
+				xlogctl->recoveryTargetMode = RECOVERY_TARGET_PAUSE_ALL;
+				xlogctl->recoveryTargetAdvance = 0;
+				SpinLockRelease(&xlogctl->info_lck);
+			}
+
+			pg_usleep(200000L);
+		}
+
+		/*
+		 * We leave the loop at the bottom only if our recovery mode is
+		 * set (or has been recently reset) to one of the stop options.
+		 */
+	} while (paused);
+
+	/*
+	 * Decide how to act if stop target mode set. We run this separately from
+	 * pause to allow user to reset their stop target while paused.
+	 */
+	switch (recoveryTargetMode)
+	{
+		case RECOVERY_TARGET_STOP_IMMEDIATE:
+				ereport(LOG,
+						(errmsg("recovery stopping immediately due to user request")));
+				return true;
+
+		case RECOVERY_TARGET_STOP_XID:
+				/*
+				 * there can be only one transaction end record with this exact
+				 * transactionid
+				 *
+				 * when testing for an xid, we MUST test for equality only, since
+				 * transactions are numbered in the order they start, not the order
+				 * they complete. A higher numbered xid will complete before you about
+				 * 50% of the time...
+				 */
+				if (is_xact_completion_record)
+				{
+					stopsHere = (record->xl_xid == recoveryTargetXid);
+					if (stopsHere)
+						*includeThis = recoveryTargetInclusive;
+				}
+				break;
+
+		case RECOVERY_TARGET_STOP_TIME:
+				/*
+				 * there can be many transactions that share the same commit time, so
+				 * we stop after the last one, if we are inclusive, or stop at the
+				 * first one if we are exclusive
+				 */
+				if (is_xact_completion_record)
+				{
+					if (recoveryTargetInclusive)
+						stopsHere = (recoveryLastXTime > recoveryTargetTime);
+					else
+						stopsHere = (recoveryLastXTime >= recoveryTargetTime);
+					if (stopsHere)
+						*includeThis = false;
+				}
+				break;
 	}
 
 	if (stopsHere)
 	{
+		Assert(is_xact_completion_record);
 		recoveryStopXid = record->xl_xid;
-		recoveryStopTime = recordXtime;
+		recoveryStopTime = recoveryLastXTime;
 		recoveryStopAfter = *includeThis;
 
 		if (record_info == XLOG_XACT_COMMIT)
@@ -5164,14 +5438,327 @@ recoveryStopsHere(XLogRecord *record, bool *includeThis)
 								recoveryStopXid,
 								timestamptz_to_str(recoveryStopTime))));
 		}
+	}
 
-		if (recoveryStopAfter)
-			recoveryLastXTime = recordXtime;
+	return stopsHere;
+}
+
+static void
+recoveryPausesAfterLSN(void)
+{
+	while (recoveryTargetMode == RECOVERY_TARGET_PAUSE_LSN &&
+			XLByteLE(recoveryTargetLSN, LastRec))
+	{
+		{
+			/* use volatile pointer to prevent code rearrangement */
+			volatile XLogCtlData *xlogctl = XLogCtl;
+
+			SpinLockAcquire(&xlogctl->info_lck);
+			recoveryTargetMode = xlogctl->recoveryTargetMode;
+			recoveryTargetLSN = xlogctl->recoveryTargetLSN;
+			SpinLockRelease(&xlogctl->info_lck);
+		}
+
+		pg_usleep(25000L);
 	}
+}
+
+/*
+ * Utility function used by various user functions to set the recovery
+ * target mode. This allows user control over the progress of recovery.
+ */
+static void
+SetRecoveryTargetMode(int mode, TransactionId xid, TimestampTz ts,
+						XLogRecPtr lsn, int advance)
+{
+	if (!RecoveryInProgress())
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("recovery is not in progress"),
+				 errhint("WAL control functions can only be executed during recovery.")));
+
+	if (!InRecovery && !superuser())
+		ereport(ERROR,
+				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+				 errmsg("must be superuser to control recovery")));
+
+
+	{
+		/* use volatile pointer to prevent code rearrangement */
+		volatile XLogCtlData *xlogctl = XLogCtl;
+
+		SpinLockAcquire(&xlogctl->info_lck);
+		xlogctl->recoveryTargetMode = mode;
+
+		if (mode == RECOVERY_TARGET_STOP_XID ||
+			mode == RECOVERY_TARGET_PAUSE_XID)
+			xlogctl->recoveryTargetXid = xid;
+		else if (mode == RECOVERY_TARGET_STOP_TIME ||
+				  mode == RECOVERY_TARGET_PAUSE_TIME)
+			xlogctl->recoveryTargetTime = ts;
+		else if (mode == RECOVERY_TARGET_ADVANCE)
+			xlogctl->recoveryTargetAdvance = advance;
+		else if (mode == RECOVERY_TARGET_PAUSE_LSN)
+			xlogctl->recoveryTargetLSN = lsn;
+
+		SpinLockRelease(&xlogctl->info_lck);
+	}
+}
+
+/*
+ * Forces recovery mode to reset to unfrozen.
+ * Returns void.
+ */
+Datum
+pg_recovery_continue(PG_FUNCTION_ARGS)
+{
+	SetRecoveryTargetMode(RECOVERY_TARGET_NONE,
+							InvalidTransactionId, 0, InvalidXLogRecPtr, 0);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * Pause recovery immediately. Stays paused until asked to play again.
+ * Returns void.
+ */
+Datum
+pg_recovery_pause(PG_FUNCTION_ARGS)
+{
+	SetRecoveryTargetMode(RECOVERY_TARGET_PAUSE_ALL,
+							InvalidTransactionId, 0, InvalidXLogRecPtr, 0);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * Pause recovery at stated xid, if ever seen. Once paused, stays paused
+ * until asked to play again.
+ */
+Datum
+pg_recovery_pause_xid(PG_FUNCTION_ARGS)
+{
+	int			  xidi = PG_GETARG_INT32(0);
+	TransactionId xid = (TransactionId) xidi;
+
+	if (xid < 3)
+		elog(ERROR, "cannot specify special values for transaction id");
+
+	SetRecoveryTargetMode(RECOVERY_TARGET_PAUSE_XID,
+							xid, 0, InvalidXLogRecPtr, 0);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * Pause recovery at stated timestamp, if ever reached. Once paused, stays paused
+ * until asked to play again.
+ */
+Datum
+pg_recovery_pause_time(PG_FUNCTION_ARGS)
+{
+	TimestampTz ts = PG_GETARG_TIMESTAMPTZ(0);
+
+	SetRecoveryTargetMode(RECOVERY_TARGET_PAUSE_TIME,
+							InvalidTransactionId, ts, InvalidXLogRecPtr, 0);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * Pause recovery after stated LSN, if ever reached. Once paused, stays paused
+ * until asked to play again.
+ */
+Datum
+pg_recovery_pause_lsn(PG_FUNCTION_ARGS)
+{
+	XLogRecPtr lsn;
+
+	lsn.xlogid = PG_GETARG_INT32(0);
+	lsn.xrecoff = PG_GETARG_INT32(1);
+
+	SetRecoveryTargetMode(RECOVERY_TARGET_PAUSE_LSN,
+							InvalidTransactionId, 0, lsn, 0);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * If paused, advance N records.
+ */
+Datum
+pg_recovery_advance(PG_FUNCTION_ARGS)
+{
+	int adv = PG_GETARG_INT32(0);
+
+	if (adv < 1)
+		elog(ERROR, "recovery advance must be greater than or equal to 1");
+
+	SetRecoveryTargetMode(RECOVERY_TARGET_ADVANCE,
+							InvalidTransactionId, 0, InvalidXLogRecPtr, adv);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * Forces recovery to stop now if paused, or at end of next record if playing.
+ */
+Datum
+pg_recovery_stop(PG_FUNCTION_ARGS)
+{
+	SetRecoveryTargetMode(RECOVERY_TARGET_STOP_IMMEDIATE,
+							InvalidTransactionId, 0, InvalidXLogRecPtr, 0);
+
+	PG_RETURN_VOID();
+}
+
+Datum
+pg_current_recovery_target(PG_FUNCTION_ARGS)
+{
+	StringInfoData buf;
+
+	initStringInfo(&buf);
+
+	{
+		/* use volatile pointer to prevent code rearrangement */
+		volatile XLogCtlData *xlogctl = XLogCtl;
+
+		SpinLockAcquire(&xlogctl->info_lck);
+
+		recoveryTargetMode = xlogctl->recoveryTargetMode;
+		if (recoveryTargetMode != RECOVERY_TARGET_NONE)
+		{
+			recoveryTargetXid = xlogctl->recoveryTargetXid;
+			recoveryTargetTime = xlogctl->recoveryTargetTime;
+			recoveryTargetAdvance = xlogctl->recoveryTargetAdvance;
+		}
+
+		SpinLockRelease(&xlogctl->info_lck);
+	}
+
+	switch (recoveryTargetMode)
+	{
+		case RECOVERY_TARGET_NONE:
+				appendStringInfo(&buf, "No recovery target has been set");
+				break;
+		case RECOVERY_TARGET_PAUSE_ALL:
+				appendStringInfo(&buf, "Recovery paused");
+				break;
+		case RECOVERY_TARGET_PAUSE_XID:
+				appendStringInfo(&buf, "Recovery will pause after commit of transaction %u", recoveryTargetXid);
+				break;
+		case RECOVERY_TARGET_PAUSE_TIME:
+				appendStringInfo(&buf, "Recovery will pause after transaction completion timestamp %s",
+										timestamptz_to_str(recoveryTargetTime));
+				break;
+		case RECOVERY_TARGET_PAUSE_LSN:
+				appendStringInfo(&buf, "Recovery will pause after applying record at xlog location %X/%X",
+										recoveryTargetLSN.xlogid,
+										recoveryTargetLSN.xrecoff);
+				break;
+		case RECOVERY_TARGET_ADVANCE:
+				appendStringInfo(&buf, "Recovery will advance");
+				break;
+		case RECOVERY_TARGET_STOP_IMMEDIATE:
+				appendStringInfo(&buf, "No recovery target has been set");
+				break;
+		case RECOVERY_TARGET_STOP_XID:
+				appendStringInfo(&buf, "Recovery will stop after commit of transaction %u", recoveryTargetXid);
+				break;
+		case RECOVERY_TARGET_STOP_TIME:
+				appendStringInfo(&buf, "Recovery will stop after transaction completion timestamp %s",
+										timestamptz_to_str(recoveryTargetTime));
+				break;
+	}
+
+	PG_RETURN_TEXT_P(cstring_to_text(buf.data));
+}
+
+/*
+ * Returns bool with current recovery mode, a global state.
+ */
+Datum
+pg_is_in_recovery(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(RecoveryInProgress());
+}
+
+/*
+ * Returns timestamp of last completed transaction
+ */
+Datum
+pg_last_recovered_xact_timestamp(PG_FUNCTION_ARGS)
+{
+	/* use volatile pointer to prevent code rearrangement */
+	volatile XLogCtlData *xlogctl = XLogCtl;
+
+	SpinLockAcquire(&xlogctl->info_lck);
+	recoveryLastXTime = xlogctl->recoveryLastXTime;
+	SpinLockRelease(&xlogctl->info_lck);
+
+	PG_RETURN_TIMESTAMPTZ(recoveryLastXTime);
+}
+
+/*
+ * Returns xid of last completed transaction
+ */
+Datum
+pg_last_recovered_xid(PG_FUNCTION_ARGS)
+{
+	/* use volatile pointer to prevent code rearrangement */
+	volatile XLogCtlData *xlogctl = XLogCtl;
+
+	SpinLockAcquire(&xlogctl->info_lck);
+	recoveryLastXid = xlogctl->recoveryLastXid;
+	SpinLockRelease(&xlogctl->info_lck);
+
+	PG_RETURN_INT32(recoveryLastXid);
+}
+
+/*
+ * Returns xlog location of last recovered WAL record.
+ */
+Datum
+pg_last_recovered_xlog_location(PG_FUNCTION_ARGS)
+{
+	/* use volatile pointer to prevent code rearrangement */
+	volatile XLogCtlData *xlogctl = XLogCtl;
+	char		location[MAXFNAMELEN];
+
+	SpinLockAcquire(&xlogctl->info_lck);
+	LastRec = xlogctl->recoveryLastRecPtr;
+	SpinLockRelease(&xlogctl->info_lck);
+
+	snprintf(location, sizeof(location), "%X/%X",
+			 LastRec.xlogid, LastRec.xrecoff);
+	PG_RETURN_TEXT_P(cstring_to_text(location));
+}
+
+/*
+ * Returns delay in milliseconds, or -1 if delay too large
+ */
+int
+GetLatestReplicationDelay(void)
+{
+	long		delay_secs;
+	int			delay_usecs;
+	int			delay;
+	TimestampTz currTz = GetCurrentTimestamp();
+
+	TimestampDifference(recoveryLastXTime, currTz,
+						&delay_secs, &delay_usecs);
+
+	/*
+	 * If delay is very large we probably aren't looking at
+	 * a replication situation at all, just a recover from backup.
+	 * So return a special value instead.
+	 */
+	if (delay_secs > (long)(INT_MAX / 1000))
+		delay = -1;
 	else
-		recoveryLastXTime = recordXtime;
+		delay = (int)(delay_secs * 1000) + (delay_usecs / 1000);
 
-	return stopsHere;
+	return delay;
 }
 
 /*
@@ -5186,7 +5773,6 @@ StartupXLOG(void)
 	bool		reachedStopPoint = false;
 	bool		haveBackupLabel = false;
 	XLogRecPtr	RecPtr,
-				LastRec,
 				checkPointLoc,
 				backupStopLoc,
 				EndOfLog;
@@ -5271,6 +5857,16 @@ StartupXLOG(void)
 	 */
 	readRecoveryCommandFile();
 
+	/*
+	 * PostAuthDelay is a debugging aid for investigating problems in startup
+	 * and/or recovery: it can be set in postgresql.conf to allow time to
+	 * attach to the newly-forked backend with a debugger. It can also be set
+	 * using the postmaster -W switch, which can be specified using the -o
+	 * option of pg_ctl, e.g. pg_ctl -D data -o "-W 30"
+	 */
+	if (PostAuthDelay > 0)
+		pg_usleep(PostAuthDelay * 1000000L);
+
 	/* Now we can determine the list of expected TLIs */
 	expectedTLIs = readTimeLineHistory(recoveryTargetTLI);
 
@@ -5533,7 +6129,9 @@ StartupXLOG(void)
 			do
 			{
 #ifdef WAL_DEBUG
-				if (XLOG_DEBUG)
+				if (XLOG_DEBUG ||
+					(rmid == RM_XACT_ID && trace_recovery_messages <= DEBUG2) ||
+					(rmid != RM_XACT_ID && trace_recovery_messages <= DEBUG3))
 				{
 					StringInfoData buf;
 
@@ -5561,13 +6159,6 @@ StartupXLOG(void)
 				}
 
 				/*
-				 * Check if we were requested to exit without finishing
-				 * recovery.
-				 */
-				if (shutdown_requested)
-					proc_exit(1);
-
-				/*
 				 * Have we passed our safe starting point? If so, we can tell
 				 * postmaster that the database is consistent now.
 				 */
@@ -5579,8 +6170,17 @@ StartupXLOG(void)
 					{
 						ereport(LOG,
 							  (errmsg("consistent recovery state reached")));
+						if (InHotStandby && IsRunningXactDataValid())
+						{
+							InitRecoveryTransactionEnvironment();
+							StartCleanupDelayStats();
+						}
 						if (IsUnderPostmaster)
 							SendPostmasterSignal(PMSIGNAL_RECOVERY_CONSISTENT);
+						if (InHotStandby && IsRunningXactDataValid() &&
+							recoveryStartsPaused)
+							SetRecoveryTargetMode(RECOVERY_TARGET_PAUSE_ALL,
+								InvalidTransactionId, 0, InvalidXLogRecPtr, 0);
 					}
 				}
 
@@ -5624,6 +6224,8 @@ StartupXLOG(void)
 
 				LastRec = ReadRecPtr;
 
+				recoveryPausesAfterLSN();
+
 				record = ReadRecord(NULL, LOG);
 			} while (record != NULL && recoveryContinue);
 
@@ -5844,6 +6446,9 @@ StartupXLOG(void)
 	ShmemVariableCache->latestCompletedXid = ShmemVariableCache->nextXid;
 	TransactionIdRetreat(ShmemVariableCache->latestCompletedXid);
 
+	/* Shutdown the recovery environment. */
+	XactClearRecoveryTransactions();
+
 	/* Start up the commit log and related stuff, too */
 	StartupCLOG();
 	StartupSUBTRANS(oldestActiveXID);
@@ -5917,8 +6522,9 @@ RecoveryInProgress(void)
 
 		/*
 		 * Initialize TimeLineID and RedoRecPtr when we discover that recovery
-		 * is finished.  (If you change this, see also
-		 * LocalSetXLogInsertAllowed.)
+		 * is finished. InitPostgres() relies upon this behaviour to ensure
+		 * that InitXLOGAccess() is called at backend startup.  (If you change
+		 * this, see also LocalSetXLogInsertAllowed.)
 		 */
 		if (!LocalRecoveryInProgress)
 			InitXLOGAccess();
@@ -6104,7 +6710,7 @@ InitXLOGAccess(void)
 {
 	/* ThisTimeLineID doesn't change so we need no lock to copy it */
 	ThisTimeLineID = XLogCtl->ThisTimeLineID;
-	Assert(ThisTimeLineID != 0);
+	Assert(ThisTimeLineID != 0 || IsBootstrapProcessingMode());
 
 	/* Use GetRedoRecPtr to copy the RedoRecPtr safely */
 	(void) GetRedoRecPtr();
@@ -6697,6 +7303,17 @@ CreateCheckPoint(int flags)
 									 CheckpointStats.ckpt_segs_recycled);
 
 	LWLockRelease(CheckpointLock);
+
+	/*
+	 * Take a snapshot of running transactions and write this to WAL.
+	 * This allows us to reconstruct the state of running transactions
+	 * during archive recovery, if required.
+	 *
+	 * If we are shutting down, or Startup process is completing crash
+	 * recovery we don't need to write running xact data.
+	 */
+	if (!shutdown && !RecoveryInProgress())
+		LogCurrentRunningXacts();
 }
 
 /*
@@ -6735,6 +7352,11 @@ RecoveryRestartPoint(const CheckPoint *checkPoint)
 	volatile XLogCtlData *xlogctl = XLogCtl;
 
 	/*
+	 * Regular reports of wait statistics. Unrelated to restartpoints.
+	 */
+	ReportCleanupDelayStats();
+
+	/*
 	 * Is it safe to checkpoint?  We must ask each of the resource managers
 	 * whether they have any partial state information that might prevent a
 	 * correct restart from this point.  If so, we skip this opportunity, but
@@ -6745,7 +7367,7 @@ RecoveryRestartPoint(const CheckPoint *checkPoint)
 		if (RmgrTable[rmid].rm_safe_restartpoint != NULL)
 			if (!(RmgrTable[rmid].rm_safe_restartpoint()))
 			{
-				elog(DEBUG2, "RM %d not safe to record restart point at %X/%X",
+				elog(trace_recovery(DEBUG2), "RM %d not safe to record restart point at %X/%X",
 					 rmid,
 					 checkPoint->redo.xlogid,
 					 checkPoint->redo.xrecoff);
@@ -6969,6 +7591,9 @@ xlog_redo(XLogRecPtr lsn, XLogRecord *record)
 	{
 		Oid			nextOid;
 
+		if (InArchiveRecovery)
+			(void) RecordKnownAssignedTransactionIds(lsn, record->xl_xid);
+
 		memcpy(&nextOid, XLogRecGetData(record), sizeof(Oid));
 		if (ShmemVariableCache->nextOid < nextOid)
 		{
@@ -6988,6 +7613,9 @@ xlog_redo(XLogRecPtr lsn, XLogRecord *record)
 		MultiXactSetNextMXact(checkPoint.nextMulti,
 							  checkPoint.nextMultiOffset);
 
+		/* We know nothing was running on the master at this point */
+		XactClearRecoveryTransactions();
+
 		/* ControlFile->checkPointCopy always tracks the latest ckpt XID */
 		ControlFile->checkPointCopy.nextXidEpoch = checkPoint.nextXidEpoch;
 		ControlFile->checkPointCopy.nextXid = checkPoint.nextXid;
@@ -7098,6 +7726,9 @@ xlog_outrec(StringInfo buf, XLogRecord *record)
 					 record->xl_prev.xlogid, record->xl_prev.xrecoff,
 					 record->xl_xid);
 
+	appendStringInfo(buf, "; len %u",
+					 record->xl_len);
+
 	for (i = 0; i < XLR_MAX_BKP_BLOCKS; i++)
 	{
 		if (record->xl_info & XLR_SET_BKP_BLOCK(i))
@@ -7254,6 +7885,12 @@ pg_start_backup(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 				 errmsg("must be superuser to run a backup")));
 
+	if (RecoveryInProgress())
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("recovery is in progress"),
+				 errhint("WAL control functions cannot be executed during recovery.")));
+
 	if (!XLogArchivingActive())
 		ereport(ERROR,
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
@@ -7441,6 +8078,12 @@ pg_stop_backup(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 				 (errmsg("must be superuser to run a backup"))));
 
+	if (RecoveryInProgress())
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("recovery is in progress"),
+				 errhint("WAL control functions cannot be executed during recovery.")));
+
 	if (!XLogArchivingActive())
 		ereport(ERROR,
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
